------------------------------------------------------------------------------------------------------------------------
-- helper.lua - add helper with grig,rulers,framestack info and more  
-- wow addon by Applesinych  [k.shabordin@gmail.com]
------------------------------------------------------------------------------------------------------------------------

local line,DB,panel,util = SNT_INFO.line,SNT_INFO.DB,SNT_INFO.panel,SNT_INFO.util  -- use globals

local CreateFrame,GetCursorPosition,insert,format = CreateFrame,GetCursorPosition,table.insert,string.format
 
local lines = {}
local helper

local function grid(size,color)
   local sx,sy = GetScreenWidth(),GetScreenHeight()  
   for ndx = 0,sx/size do table.insert(lines,line:new("v",ndx*size,0,1,sy,color,false)) end   
   for ndx = 0,sy/size do table.insert(lines,line:new("h",0,ndx*size,1,sx,color,false)) end   
end

local function frame_info(frame)
   local out_string = ""
   if(frame) then
      local name = frame:GetName() 
         if(name) then
            out_string = out_string..name
            local parent = frame:GetParent()
            if(parent) then out_string = out_string.." -> "..frame_info(parent) end
         else out_string = "no name" end   
   end
   return out_string
end   

local function create_helper()
   local sx,sy  = GetScreenWidth(),GetScreenHeight()  
   helper  = panel:new(); helper:do_movable(); helper:point(20,20,0,350)
   helper.frame:SetScript("OnUpdate",function() 
                                    local x,y   = GetCursorPosition()
                                    helper:add_text(format("|cffff00aax= %d, y= %d|r|cff999999 [%1.2f]|r|cffaaffff [%s]|r",
                                    x,y,UIParent:GetEffectiveScale(),frame_info(GetMouseFocus())),true)
                              end)
   helper:show()
   grid(sx/64,DB.HLP_std_col)
   grid(sx/16,DB.HLP_2step_col) 
   table.insert(lines,line:new("v",sx/2,0,2,sy,DB.HLP_center_col,false))
   table.insert(lines,line:new("h",0,sy/2,2,sx,DB.HLP_center_col,false))
   table.insert(lines,line:new("v",0,0,2,sy,DB.HLP_ruler_col,true))
   table.insert(lines,line:new("h",0,0,3,sx,DB.HLP_ruler_col,true))
   DB.lock = false
end

local function kill_helper()
   for _,l in ipairs(lines) do l.frame:Hide() end
   lines    = {}
   helper:hide(); helper = nil
   DB.lock = true
end

local hide = true
SlashCmdList["HELPER"] = function(...)
   if(hide) then create_helper() else kill_helper() end
   hide = not hide
end
SLASH_HELPER1 = '/helper'
SLASH_HELPER2 = '/hlp'
